/* Simulazione di tema d'esame del 07/05/2009 */

#include <stdio.h>
#include <math.h>
#include <strings.h>

void elabora_valori(FILE *finput, FILE *foutput); 

int main(int argc, char *argv[])
{
	FILE *fin, *fout;      /* Sono il file di origine e di destinazione */
	
	if(argc != 3)
	{	
		printf("ERRORE: devi inserire i file di origine e di destinazione.\n"); /* Controllo sul numero di argomenti */
		return -1;
	}
	
	fin = fopen(argv[1], "r");            /* Apertura file */
	fout = fopen(argv[2], "w");
	
	if(fin == NULL || fout == NULL)
	{	
		printf("ERRORE: non posso aprire uno dei file specificati.\n");  /* Controllo sull'esattezza dei file */
		return -1;
	}
	
	elabora_valori(fin, fout);
	
	fclose(fin);                                  /* Chiudo i file aperti */
	fclose(fout);
	
	return 0;
}
	
		
void elabora_valori(FILE *finput, FILE *foutput) 
{
	char buf[20];                          /* Per la riga */
	int a, b, sommac1=0, sommac2=0;        /* I valori sulle righe e la somma delle colonne */
	double c;
	int val;                               /* Il valore di ritorno della sscanf */
	
	while((fgets(buf, sizeof(buf), finput)) != NULL)             /* Esco quando finisco il file */
	{
		val = sscanf(buf, "%i %i", &a, &b);                   /* Leggo i valori dalla riga */
		if(val != 2)                                          /* Controllo di coerenza sul numero dei valori */
		{	
			printf("ERRORE nel file di dati.\n");
			exit(-1);
		}
		if(a != 0 && b >= 0)                                   /* Controllo CE */
		{
			c= 1.0/a + sqrt(b);
			fprintf(foutput,"%i %i %lf\n", a, b, c);
		}
		else                                                   /* Se il calcolo non  possibile...*/
		{
			fprintf(foutput, "%i %i %s\n", a, b, "NO");
		}
		sommac1 += a;
		sommac2 += b;
	}	
	printf("Le somme delle colonne sono: %i e %i.\n", sommac1, sommac2);         /* Stampo le somme */
}
	
	
	
	
	
	
	
	
