/* Soluzione del tema d'esame del 19/7/2010, sede di Mantova */

/* Un file contiene una serie di date, una su ciascuna riga, rappresentate nel seguente formato:
GG MESE AAAA
dove:
• GG nel range [01, ..., 31] rappresenta il giorno, in formato numerico (due cifre);
• MESE è una stringa del tipo [GENNAIO, FEBBRAIO, ..., DICEMBRE];
• AAAA è il valore numerico che rappresenta l'anno (quattro cifre);

Il programma deve leggere l'intero file ed effettuare la seguente elaborazione dei dati letti:
1. calcolare la media tra gli anni (campo AAAA) di tutte le date
2. conteggiare quante date sono presenti per ogni mese dell'anno
3. conteggiare quanti sono i giorni (campo GG) pari e quelli dispari su tutte le date lette
4. determinare le N date più vecchie e le M più recenti tra tutte quelle lette, con N ed M
valori interi forniti dall'utente

NB: non è necessario che il formato di memorizzazione usato dal programma sia lo stesso di
quello utilizzato nel file.
*/


#include<stdio.h>
#include<string.h>
#include<stdlib.h>

#define TRACE printf("DEBUG... %s: %d\n", __func__, __LINE__);


typedef struct
{
	int a;
	int m;
	int g;
} DATA;
int nd=0;
char *mesi[]={"GENNAIO", "FEBBRAIO", "MARZO", "APRILE", "MAGGIO", "GIUGNO", "LUGLIO", "AGOSTO", "SETTEMBRE", "OTTOBRE", "NOVEMBRE", "DICEMBRE"};


int to_numero(char *mese)
{
	int i;
	
	for(i=0; i<12; i++)
		if(strcmp(mese, mesi[i]) == 0)
			return i+1;
	printf("ERRORE NELLA LOGICA DEL PROGRAMMA\n");
	exit(-11);
}


DATA *carica_struct(FILE *f)
{
	int dim=5;
	DATA *v;
	char linea[100], mese[50];
	
	if(!(v=malloc(dim*sizeof(DATA))))
		return NULL;
	
	while(fgets(linea, sizeof(linea), f) != NULL)
	{
		if(sscanf(linea, "%d %s %d", &((v+nd)->g), mese, &((v+nd)->a)) != 3)
			return NULL;
		(v+nd)->m = to_numero(mese);
		nd++;
		if(nd >= dim)
		{
			dim *= 2;
			if(!(v=realloc(v, dim * sizeof(DATA))))
				return NULL;
		}
	}
	
	return v;
}


void media_anni(DATA *v)
{
	int i;
	float media=0;
	
	for(i=0; i<nd; i++)
		media += ((v+i)->a)/(float)nd;
	printf("\nMedia anni: %.2f\n", media);
}


void conta_mesi(DATA *v)
{
	int i;
	int count[12]={0};
	
	for(i=0; i<nd; i++)
		count[(v+i)->m - 1]++;
	printf("\nConteggio occorrenze mesi:\n");
	for(i=0; i<12; i++)
		printf("%s: %2d\n", mesi[i], count[i]);
}
		

void pari_dispari(DATA *v)
{
	int pari=0, dispari=0, i;
	
	for(i=0; i<nd; i++)
	{
		if(((v+i)->g)%2 == 0)
			pari++;
		else
			dispari++;
	}
	printf("\nPari: %2d Dispari: %2d\n", pari, dispari);
}
	

int cmp_date(const void *p1p, const void *p2p)
{
	DATA *p1 = (DATA *)p1p, *p2 = (DATA *)p2p;
	int ret;
	if(!(ret = p1->a - p2->a))
	{
		if(!(ret = p1->m - p2->m))
			ret = p1->g - p2->g;
	}
	return ret;
}

void vecchie_nuove(DATA *v, int nuove, int vecchie)
{
	int i;
	
	qsort(v, nd, sizeof(DATA), cmp_date);
	
	printf("\nDate più lontane:\n");
	for(i=0; i<vecchie && i<nd; i++)
		printf("%2d -> %02d %s %4d\n", i+1, (v+i)->g, mesi[(v+i)->m - 1], (v+i)->a);
	printf("Date più recenti:\n");
	for(i = nd-1; i>=0 && (i > nd-1-vecchie); i--)
		printf("%2d -> %02d %s %4d\n", nd-i, (v+i)->g, mesi[(v+i)->m -1], (v+i)->a);
}
	

int main(int argc, char *argv[])
{
	FILE *fin;
	DATA *p;
	
	if (argc != 4)
	{
		printf("UTILIZZO: ./date intfile N(recenti) M(datate)\n");
		return -1;
	}
	
	if(!(fin=fopen(argv[1], "r")))
	{
		printf("ERRORE nell'apertura del file\n");
		return -2;
	}
	
	p = carica_struct(fin);
	if(p==NULL)
	{
		printf("ERRORE nella lettura del file\n");
		return -3;
	}
	
	media_anni(p);
	conta_mesi(p);
	pari_dispari(p);
	vecchie_nuove(p, atoi(argv[2]), atoi(argv[3]));
	
	free(p);
	fclose(fin);
	
	return 0;
}

/* NO FATE BUT WHAT WE MAKE */
