/* Esame di informatica di Mantova del 1-feb-2011 */

#include<stdio.h>
#include<string.h>
#include<stdlib.h>
#include<math.h>

#define MAXGR 15
#define MAXA 100


void elabora_p(int n, double x, double *a, FILE *fout)                /* Calcola il valore del polinomio e lo stampa */
{
	double valore=0;                                             /* Il valore del polinomio */
	int i=0;
	
	for(i = 0; i < n+1; i++)                                     /* Calcolo il valore di ogni termine e lo aggiungo alla somma */
	{
		valore += a[i] * pow(x, i);
	}
	
	fprintf(fout,"Il valore : %lf\n", valore);
}


void otput(FILE *fin, FILE *fout)                                     /* Acquisisce i dati e si comporta di conseguenza */
{
	double x=0;
	double a[MAXGR + 1] = {0};                                    /* Il vettore dei coefficienti */
	int n=0, i;
	char linea[4096];                                             /* La stringa che contiene la riga del file */
	char *tok;
	
	while((fgets(linea, sizeof(linea), fin)) != NULL)             /* Mi fermo quando finisce il file */
	{
		tok = strtok(linea, " ");
		switch (tok[0])
		{
			case 'P':                                      /* Acquisisco il grado e i coefficienti e li memorizzo */ 
			{                                              /* per la successiva elaborazione, da operare dopo l'acq */
				tok = strtok(NULL, " ");               /* di x */
				n = atoi(tok);
				if(n > MAXGR)
				{
					printf("ERRORE! cofficiente fuori range[1 to %i]: %i\n", MAXGR, n);   /* Controllo */
					exit(-1);
				}
				for(i = 0; i < n+1; i++)
				{
					tok = strtok(NULL, " ");
					a[n-i] = atof(tok);
				}
				break;
			}
			case 'V':                                     /* Acquisisco la x e lancio la valutazione */
			{
				tok = strtok(NULL, " ");
				x = atof(tok);
				elabora_p(n, x, a, fout);
				break;
			}
			default:                                       /* NO FATE BUT WHAT WE MAKE */
			{
				printf("ERRORE nella logica di funzionamento del programma\n");
				exit(-1);
			}
		}
	}
}



int main(int argc, char *argv[])
{
	FILE *fin, *fout;
	
	if(argc != 3)
	{
		printf("ERRORE! Utilizzo: ./esame2 infile outfile\n");
		exit(-1);
	}
	
	fin = fopen(argv[1], "r");
	fout = fopen(argv[2], "w");
	
	if(fin == NULL || fout == NULL)
	{
		printf("ERRORE! Non posso aprire uno dei file.\n");
		exit(-1);
	} 
	otput(fin,fout);
	fclose(fin);
	fclose(fout);
	return 0;
}
