/* Esigo soddisfazione dell'esercizio che non compilava a tutorato...*/

#include<stdio.h>
#include<string.h>
#include<stdlib.h>

#define TRACE printf("%s: %d\n", __func__, __LINE__);
#define MAXP (30)
#define MAXS (MAXP/2)

struct driver
{
	char nome[100];
	int punti;
};

struct team
{
	char nome[100];
	int punti;
};

int numpiloti=0, numsquadre=0;
int punteggio[MAXP]={25,18,15,12,10,8,6,4,2,1,0};


void punteggio_p(char *nomep, struct driver *piloti, int pos)
{
	int i;
	
	for(i=0; i<numpiloti; i++)
	{
		if(!(strcmp(nomep, (piloti + i) -> nome)))
		{
			(piloti + i) -> punti += punteggio[pos];  
			return;
		}
	}
	
	strncpy((piloti + numpiloti)->nome, nomep, sizeof(piloti->nome));
	(piloti + numpiloti)->punti = punteggio[pos];
	numpiloti++;
	if(numpiloti>MAXP)
	{
		printf("ERRORE: numero di piloti superiore al limite massimo\n");
		exit(-2);
	} 
}

		
void punteggio_s(char *nomes, struct team *squadre, int pos)
{
	int i;
	
	for(i=0; i<numsquadre; i++)
	{
		if(!(strcmp(nomes, (squadre + i) -> nome)))
		{
			(squadre + i) -> punti += punteggio[pos];  
			return;
		}
	}
	
	strncpy((squadre + numsquadre)->nome, nomes, sizeof(squadre->nome));
	(squadre + numsquadre)->punti = punteggio[pos];
	numsquadre++;
	if(numsquadre>MAXS)
	{
		printf("ERRORE: numero di squadre superiore al limite massimo\n");
		exit(-2);
	}
}


void elabora_file(struct driver *piloti, struct team *squadre, FILE *fin)
{
	int pos=1;
	char linea[200], nomep[100], nomes[100];
	
	while((fgets(linea, sizeof(linea), fin)) != NULL)
	{
		if((sscanf(linea, "%s %s", nomep, nomes)) != 2)
		{
			printf("ERRORE nel formato della classifica\n");
			exit(-3);
		}
		punteggio_p(nomep, piloti, pos);
		punteggio_s(nomes, squadre, pos);
		pos++;
	}
}


int compara_punti_p(const void *ptr1, const void *ptr2)
{
	struct driver *pilota1 = (struct driver *) ptr1;
	struct driver *pilota2 = (struct driver *) ptr2;
	return (pilota2 -> punti) - (pilota1 -> punti);
}


int compara_punti_s(const void *ptr1, const void *ptr2)
{
	struct team *team1 = (struct team *) ptr1;
	struct team *team2 = (struct team *) ptr2;
	return (team2 -> punti) - (team1 -> punti);  
}

void ordina_classifiche(struct driver *piloti, struct team *squadre)
{
	qsort(piloti, numpiloti, sizeof(struct driver), compara_punti_p);
	qsort(squadre, numsquadre, sizeof(struct team), compara_punti_s);  
}


void stampa_ris(struct driver *piloti, struct team *squadre, int gare)
{
	int i;
	
	printf("Classifica piloti (dopo %d GP):\n", gare);
	for(i=0; i<numpiloti; i++)
		printf("%d. %s: %d punti\n", i+1, (piloti + i) -> nome, (piloti + i) -> punti);
	
	printf("\nClassifica costruttori (dopo %d GP):\n", gare);
	for(i=0; i<numsquadre; i++)
		printf("%d. %s: %d punti\n", i+1, (squadre + i) -> nome, (squadre + i) -> punti);
}   



int main(int argc, char *argv[])
{
	struct driver *piloti;
	struct team *squadre;
	int i=1;
	char nome_file[50];
	FILE *fin;
	
	if(!(piloti = malloc(MAXP * sizeof(struct driver))))
	{
		printf("ERRORE nell'allocazione della memoria.\n");
		return -1;
	}
	
	if(!(squadre = malloc(MAXS * sizeof(struct team))))
	{
		printf("ERRORE nell'allocazione della memoria.\n");
		return -1;
	}
	
	while(1)
	{
		sprintf(nome_file, "gara%02d.txt", i);
		fin = fopen(nome_file, "r");
		if(fin == NULL)
			break;
		elabora_file(piloti, squadre, fin);
		i++;
	}
	ordina_classifiche(piloti, squadre);
	stampa_ris(piloti, squadre, i-1);
	return 0;
} 

/* NO FATE BUT WHAT WE MADE */
	

