#include <stdio.h>
#include <stdlib.h>

struct vettore {
	int dim;    /* dimensioni del vettori */
	int *elem;  /* elementi del vettori */
	int somma;
};

struct file {
	int n;               /* numero di vettori */
	struct vettore *v;   /* vettori */
};

int carica_dati(char *fname, struct file *d)
{
	FILE *f;
	char st[100];
	int i, j;

	if (!(f = fopen(fname, "r")))
		return 1;

	fgets(st, sizeof(st), f);
	sscanf(st, "%d", &d->n);
	d->v = malloc(d->n * sizeof(struct vettore));

	for (i = 0; i < d->n; i++) {
		fgets(st, sizeof(st), f);
		sscanf(st, "%d", &(d->v + i)->dim);
		(d->v + i)->elem = malloc((d->v + i)->dim * sizeof(int));
		for (j = 0; j < (d->v + i)->dim; j++) {
			fgets(st, sizeof(st), f);
			sscanf(st, "%d", &(d->v + i)->elem[j]);
		}
	}

	fclose(f);

	return 0;
}

int scrivi_file(char *fname, struct file *d)
{
	FILE *f;
	int i, j;
	int max, maxi;

	if (!(f = fopen(fname, "w")))
		return 1;

	for (i = 0; i < d->n; i++) {
		fprintf(f, "%d %d\n", (d->v + i)->elem[0], (d->v + i)->elem[(d->v + i)->dim - 1]);
		(d->v + i)->somma = 0;
		for (j = 0; j < (d->v + i)->dim; j++) {
			fprintf(f, "%d ", (d->v + i)->elem[j]);
			(d->v + i)->somma += (d->v + i)->elem[j];
		}
		fprintf(f, "\n");
	}

	max = (d->v + 0)->somma;
	for (i = 1; i < d->n; i++) {
		if ((d->v + i)->somma > max) {
			max = (d->v + i)->somma;
			maxi = i;
		}
	}

	fprintf(f, "%d %d\n", max, maxi);

	fclose(f);

	return 0;
}


int cmp_int(const void *c1p, const void *c2p)
{
        int *c1 = (int *)(c1p), *c2 = (int *)(c2p);

        return (*c1 - *c2);
}

int elab_file(struct file *d)
{
	int i, j;

	for (i = 0; i < d->n; i++) {
		qsort((d->v + i)->elem, (d->v + i)->dim, sizeof(int), cmp_int);
		(d->v + i)->somma = 0;
		for (j = 0; j < (d->v + i)->dim; j++) {
			(d->v + i)->somma += (d->v + i)->elem[j];
		}
	}

	return 0;
}

int prodotto(struct file *d1, struct file *d2)
{
	int i, j, prod;

	for (i = 0; i < d1->n; i++) {
		prod = 0;
		for (j = 0; j < (d1->v + i)->dim; j++) {
			prod += (d1->v + i)->elem[j] * (d2->v + i)->elem[j];
		}
		printf("%d\n", prod);
	}

	return 0;	
}

int main (int argc, char* argv[]) {
	struct file d1, d2;

	if (carica_dati("input1.dat", &d1)) {
		perror("Errore nell'apertura di input1.dat\n");
		return 1;
	}
	if (carica_dati("input2.dat", &d2)) {
		perror("Errore nell'apertura di input2.dat\n");
		return 1;
	}

	/* calcolo e visualizzo prima di elab_file perche`
	 * il vettore non deve essere riordinato
	 */
	prodotto(&d1, &d2);

	elab_file(&d1);
	elab_file(&d2);

	if (scrivi_file("out1.dat", &d1)) {
		perror("Errore nell'apertura di out2.dat\n");
		return 1;
	}
	if (scrivi_file("out2.dat", &d2)) {
		perror("Errore nell'apertura di out2.dat\n");
		return 1;
	}

	return 0;
}
